config/routes.rb
Rails.application.routes.draw do
  devise_for :users
  root 'blog#index'

  controller :blog do
    get 'about'
    get 'contact'
    get 'blog/posts/:id' => 'blog#show_post', as: 'show'
    post 'blog/posts/:id' => 'blog#create'
  end

  resources :posts
  # For details on the DSL available within this file, see http://guides.rubyonrails.org/routing.html
end

app/models/application_record.rb
class ApplicationRecord < ActiveRecord::Base
  self.abstract_class = true
end

app/models/comment.rb
class Comment < ApplicationRecord
  belongs_to :post
end

app/models/post.rb
class Post < ApplicationRecord
  enum category: ['Ruby on Rails', 'Java', 'Ruby', 'Linux', 'OOP']
  paginates_per 3
  has_many :comments, dependent: :destroy

  def self.search(query)
    where('title like ?', "%#{query}%")
  end
end

app/models/user.rb
class User < ApplicationRecord
  # Include default devise modules. Others available are:
  # :confirmable, :lockable, :timeoutable and :omniauthable
  devise :database_authenticatable, :registerable,
         :recoverable, :rememberable, :trackable, :validatable
end

app/controllers/application_controller.rb
class ApplicationController < ActionController::Base
  # Autenticação basica http
  # http_basic_authenticate_with name: 'admin', password: 'admin', except: :index
end

app/controllers/blog_controller.rb
class BlogController < ApplicationController
  before_action :set_post, only: [:show_post]

  def index
    if params[:search].present?
      if !params[:search].blank?
        @count = Post.search(params[:search]).count
        if @count != 0
          @search = "Resultado da pesquisa: #{@count} post(s) encontrados !"
          @posts = Post.search(params[:search]).order(:title).page params[:page]
        else
          @search = 'Sua pesquisa não foi encontrado !'
          @posts = Post.order(:created_at).page params[:page]
        end
      elsif params[:search].blank?
        @search = 'Digite sua Pesquisa !'
        @posts = Post.order(:created_at).page params[:page]
      end
    else
      @posts = Post.order(:created_at).page params[:page]
    end
  end

  def show_post
    # code
  end

  def about; end

  def contact; end

  def create
    @post = Post.find(params[:id])
    @comment = @post.comments.create(comment_params)
    redirect_to show_path(@post)
  end

  private

  def set_post
    @post = Post.find(params[:id])
  end

  def comment_params
    params.require(:comment).permit(:commenter, :body, :search)
  end
end

app/controllers/comments_controller.rb
class CommentsController < ApplicationController
end

app/controllers/posts_controller.rb
class PostsController < ApplicationController
  before_action :set_post, only: %i[show edit update destroy]

  # GET /posts
  # GET /posts.json
  def index
    @posts = Post.all
  end

  # GET /posts/1
  # GET /posts/1.json
  def show; end

  # GET /posts/new
  def new
    @post = Post.new
  end

  # GET /posts/1/edit
  def edit; end

  # POST /posts
  # POST /posts.json
  def create
    @post = Post.new(post_params)

    respond_to do |format|
      if @post.save
        format.html { redirect_to @post, notice: 'Post criado com sucesso !' }
        format.json { render :show, status: :created, location: @post }
      else
        format.html { render :new }
        format.json { render json: @post.errors, status: :unprocessable_entity }
      end
    end
  end

  # PATCH/PUT /posts/1
  # PATCH/PUT /posts/1.json
  def update
    respond_to do |format|
      if @post.update(post_params)
        format.html { redirect_to @post, notice: 'Post atualizado com sucesso !' }
        format.json { render :show, status: :ok, location: @post }
      else
        format.html { render :edit }
        format.json { render json: @post.errors, status: :unprocessable_entity }
      end
    end
  end

  # DELETE /posts/1
  # DELETE /posts/1.json
  def destroy
    @post.destroy
    respond_to do |format|
      format.html { redirect_to posts_url, notice: 'Post destruido com successo !' }
      format.json { head :no_content }
    end
  end

  private

  # Use callbacks to share common setup or constraints between actions.
  def set_post
    @post = Post.find(params[:id])
  end

  # Never trust parameters from the scary internet, only allow the white list through.
  def post_params
    params.require(:post).permit(:author, :category, :title, :content, :search)
  end
end

app/helpers/application_helper.rb
module ApplicationHelper
  def title(page_title)
    content_for :title, page_title.to_s
  end

  def current_class?(test_path)
    return 'active' if request.path == test_path
    ''
  end

  def bootstrap_class_for(flash_type)
    case flash_type
    when 'success'
      'alert-success' # Green
    when 'error'
      'alert-danger' # Red
    when 'alert'
      'alert-warning' # Yellow
    when 'notice'
      'alert-info' # Blue
    else
      flash_type.to_s
    end
  end
end

app/helpers/blog_helper.rb
module BlogHelper
end

app/helpers/comments_helper.rb
module CommentsHelper
end

app/helpers/posts_helper.rb
module PostsHelper
end

app/views/blog/_form.html.erb
<%= form_with(model: [ @post, @post.comments.build ], url:{action: 'create'}, local: true) do |form| %>
<p>
  <%= form.label :commenter %><br>
  <%= form.text_field :commenter, class: "form-control", placeholder: "Autor..." %>
</p>
<p>
  <%= form.label :body %><br>
  <%= form.text_area :body, rows: 5, class: "form-control", placeholder: "Conteúdo..." %>
</p>
<p>
  <%= form.submit nil, class: "btn btn-primary" %>
</p>
<% end %>

app/views/blog/about.html.erb
<% title "Blog - Sobre" %>
  <h1 class="my-4">Blog about</h1>
  <p>
    Lorem ipsum dolor sit amet, consectetur adipisicing elit, sed do eiusmod tempor incididunt ut labore et dolore magna aliqua. Ut enim ad minim veniam, quis nostrud exercitation ullamco laboris nisi ut aliquip ex ea commodo consequat. Duis aute irure
    dolor in reprehenderit in voluptate velit esse cillum dolore eu fugiat nulla pariatur. Excepteur sint occaecat cupidatat non proident, sunt in culpa qui officia deserunt mollit anim id est laborum.
  </p>

app/views/blog/contact.html.erb
<% title "Blog - Contatos" %>
  <h1 class="my-4">Blog contact</h1>
  <form>
    <fieldset class="form-group">
      <label for="formGroupExampleInput">Example label</label>
      <input type="text" class="form-control" id="formGroupExampleInput" placeholder="Example input">
    </fieldset>
    <fieldset class="form-group">
      <label for="formGroupExampleInput2">Another label</label>
      <input type="text" class="form-control" id="formGroupExampleInput2" placeholder="Another input">
    </fieldset>
  </form>

app/views/blog/index.html.erb
<% title "Blog - Home" %>

  <h1 class="my-4">Posts Blog</h1>
  <% if !@search.blank? %>
    <h6><%= @search %></h6>
  <% end %>
  <!-- Blog Post -->
  <% @posts.each do |post| %>
    <div class="card mb-4">
      <%# <img class="card-img-top" src="http://placehold.it/750x300" alt="Card image cap"> %>
        <div class="card-header">
          <h2><%= post.title %></h2>
          <h6 class="text-muted">Categoria:
            <%= post.category %>
          </h6>
        </div>
        <div class="card-body">
          <p class="card-text"><%= post.content %></p>
          <%= link_to 'Leia mais', show_path(post), class: "btn btn-primary" %>
        </div>
        <div class="card-footer text-muted">
          Posted on
          <%= post.created_at.strftime("%d/%m/%y") %>
          by
          <%= post.author %>
        </div>
      </div>
    <% end %>

    <%= render 'layouts/pagination' %>

app/views/blog/show_post.html.erb
<% title "Blog - Posts" %>
  <% model_class = Post %>

    <h1 class="my-4">Postagem</h1>
    <div class="card mb-4 mt-2">
      <%# <img class="card-img-top" src="http://placehold.it/750x300" alt="Card image cap"> %>
        <div class="card-body">
          <h2 class="card-title"><%= @post.title %></h2>
          <h5 class="text-muted">Postado
            <%= @post.created_at.strftime("%d/%m/%Y") %>
            por
            <%= @post.author %></h5>
          <p class="card-text"><%= @post.content %></p>
        </div>
        <div class="card-footer">
          <p class="my-2 text-muted float-right">
            Comentários
            <%= @post.comments.count %>
          </p>
          <% if @post.comments.any? %>
            <h4>Comentários</h4>
            <% @post.comments.each do |comment| %>
              <div class="card mt-4">
                <div class="card-header text-muted">
                  <%= model_class.human_attribute_name(:commenter) %>
                  <%= comment.commenter %>
                </div>
                <div class="card-body">
                  <p class="card-text">
                    <%= comment.body %>
                  </p>
                </div>
                <div class="card-footer">
                  <h6 class="text-muted">Postado em
                    <%= comment.created_at.strftime("%d/%m/%Y") %>
                  </h6>
                </div>
              </div>
            <% end %>
          <% end %>
          <% if !user_signed_in? %>
            <p class="my-2 text-muted float-left">Para comentar a postagem faça
              <%= link_to 'Login', new_user_session_path %>
            </p>
          <% end %>
        </div>
      </div>
      <% if user_signed_in? %>
        <h2>Adicionar comentário:</h2>
        <%= render 'blog/form' %>
      <% end %>

app/views/layouts/_flash_messages.html.erb
<% flash.each do |type, message| %>
  <div class="alert <%= bootstrap_class_for(type) %> fade show" role="alert">
    <button type="button" class="close" data-dismiss="alert" aria-label="Close">
      <span aria-hidden="true">&times;</span>
    </button>
    <%= message %>
  </div>
<% end %>

app/views/layouts/_footer.html.erb
<!-- Footer -->
<footer class="py-5 bg-dark">
  <div class="container">
    <p class="m-0 text-center text-white">Copyright &copy; Blog 2018</p>
  </div>
  <!-- /.container -->
</footer>

app/views/layouts/_navigation.html.erb
<!-- Navigation -->
<nav class="navbar navbar-expand-lg navbar-dark bg-dark fixed-top">
  <div class="container">
    <%= link_to 'Start Blog', root_path, class: "navbar-brand" %>
    <button class="navbar-toggler" type="button" data-toggle="collapse" data-target="#navbarResponsive" aria-controls="navbarResponsive" aria-expanded="false" aria-label="Toggle navigation">
      <span class="navbar-toggler-icon"></span>
    </button>
    <div class="collapse navbar-collapse" id="navbarResponsive">
      <ul class="navbar-nav ml-auto">
        <li class="nav-item <%= current_class?(root_path) %>">
          <%= link_to 'Home', root_path, class: "nav-link" %>
        </li>
        <li class="nav-item <%= current_class?(about_path) %>">
          <%= link_to 'Sobre', about_path, class: "nav-link" %>
        </li>
        <li class="nav-item <%= current_class?(contact_path) %>">
          <%= link_to 'Contato', contact_path, class: "nav-link" %>
        </li>
        <% if user_signed_in? %>
          <li class="nav-item <%= current_class?(destroy_user_session_path) %>">
            <%= link_to 'Logout', destroy_user_session_path, class: "btn btn-outline-danger" %>
          </li>
        <% else %>
          <li class="nav-item <%= current_class?(new_user_session_path) %>">
            <%= link_to 'Login', new_user_session_path, class: "btn btn-outline-success" %>
          </li>
        <% end %>
      </ul>
    </div>
  </div>
</nav>

app/views/layouts/_pagination.html.erb
<!-- Pagination -->
<%#
<ul class="pagination justify-content-center mb-4">
  <li class="page-item">
    <a class="page-link" href="#">&larr; Older</a>
  </li>
  <li class="page-item disabled">
    <a class="page-link" href="#">Newer &rarr;</a>
  </li>
</ul> %>
  <%= paginate @posts, theme: 'twitter-bootstrap-4', pagination_class: 'justify-content-center mb-4' %>

app/views/layouts/_sidebar.html.erb
<!-- Sidebar Widgets Column -->
<!-- Search Widget -->
<div class="card my-4">
  <h5 class="card-header">Pesquisar</h5>
  <div class="card-body">
    <div class="input-group">
      <%= form_tag root_path, method: :get, class: "form-inline" do %>
      <%= text_field_tag( :search, params[:search], placeholder: "Search", class: "form-control" ) %>
      <span class="input-group-btn">
        <%= submit_tag 'OK', class: "btn btn-secondary" %>
      </span>
    <% end %>
  </div>
</div>
</div>

<!-- Categories Widget -->
<div class="card my-4">
<h5 class="card-header">Categorias</h5>
<div class="card-body">
  <div class="row">
    <div class="col-6">
      <ul class="list-unstyled mb-0">
        <li>
          <%= link_to 'Ruby on Rails', '#', class: "btn btn-outline-primary" %>
        </li>
        <li>
          <%= link_to 'Ruby', '#', class: "btn btn-outline-primary" %>
        </li>
        <li>
          <%= link_to 'Java', '#', class: "btn btn-outline-primary" %>
        </li>
      </ul>
    </div>
    <div class="col-6">
      <ul class="list-unstyled mb-0">
        <li>
          <%= link_to 'Linux', '#', class: "btn btn-outline-primary" %>
        </li>
        <li>
          <%= link_to 'OOP', '#', class: "btn btn-outline-primary" %>
        </li>
        <li>
          <%= link_to 'WebDesign', '#', class: "btn btn-outline-primary" %>
        </li>
      </ul>
    </div>
  </div>
</div>
</div>

<!-- Side Widget -->
<div class="card my-4">
<h5 class="card-header">Side Widget</h5>
<div class="card-body">
  You can put anything you want inside of these side widgets. They are easy to use, and feature the new Bootstrap 4 card containers!
</div>
</div>

app/views/layouts/application.html.erb
<!DOCTYPE html>
<html>
  <head>
    <title><%= yield :title %></title>
    <%= csrf_meta_tags %>
    <%= csp_meta_tag %>

    <%= stylesheet_link_tag 'application', media: 'all', 'data-turbolinks-track': 'reload' %>
    <%= javascript_include_tag 'application', 'data-turbolinks-track': 'reload' %>
  </head>

  <body>
    <%= render 'layouts/navigation' %>
    <!-- Page Content -->
    <div class="container">
      <div class="row">
        <div class="col">
          <%= render 'layouts/flash_messages' %>
        </div>
      </div>
      <div class="row">
        <!-- Conteúdo da Página-->
        <div class="col-8">
          <%= yield %>
        </div>
        <!-- SideBar da Página-->
        <div class="col-4">
          <%= render 'layouts/sidebar' %>
        </div>
      </div>
    </div>
    <%= render 'layouts/footer' %>
  </body>
</html>

app/views/posts/_form.html.erb
<%= form_with(model: post, local: true) do |form| %>
<% if post.errors.any? %>
  <div class="alert alert-danger" role="alert">
    <h2><%= pluralize(post.errors.count, "error") %>
      prohibited this post from being saved:</h2>

    <ul>
      <% post.errors.full_messages.each do |message| %>
        <li><%= message %></li>
      <% end %>
    </ul>
  </div>
<% end %>

<div class="form-group">
  <%= form.label :author %>
  <%= form.text_field :author, class: "form-control" %>
</div>

<div class="form-group">
  <%= form.label :title %>
  <%= form.text_field :title, class: "form-control" %>
</div>
<div class="form-group">
  <%= form.label :category %>
  <%= form.select :category, options_for_select(['Ruby on Rails','Java','Ruby','Linux','OOP'], :selected => form.object.category),{prompt: true}, class: "form-control" %>
</div>

<div class="form-group">
  <%= form.label :content %>
  <%= form.text_area :content, class: "form-control" %>
</div>

<div class="form-group">
  <%= form.submit nil, class: "btn btn-primary"%>
</div>
<% end %>

app/views/posts/edit.html.erb
<% model_class = Post %>
  <div class="my-4">
    <h1><%= t('.edit', default: t('helpers.titles.edit', model: model_class.model_name.human)) %></h1>
  </div>

  <%= render 'form', post: @post %>

  <%= link_to t('.show', default: t('helpers.links.show')), @post, class: "btn btn-info btn-sm" %>
  |
  <%= link_to t('.back', default: t('helpers.links.back')), posts_path, class: "btn btn-danger btn-sm" %>

app/views/posts/index.html.erb
<% model_class = Post %>

  <div class="my-4">
    <h1><%= model_class.model_name.human.pluralize.titleize %></h1>
  </div>
  <table class="table table-sm">
    <thead>
      <tr>
        <th scope="col"><%= model_class.human_attribute_name(:author) %></th>
        <th scope="col"><%= model_class.human_attribute_name(:title) %></th>
        <th scope="col"><%= model_class.human_attribute_name(:content) %></th>
        <th scope="col" colspan="3" class="text-center"><%= t('.actions', default: t('helpers.links.actions')) %></th>
      </tr>
    </thead>

    <tbody>
      <% @posts.each do |post| %>
        <tr>
          <td scope="row"><%= post.author %></td>
          <td><%= post.title %></td>
          <td><%= truncate(post.content, lenght: 10) %></td>
          <td><%= link_to t('.show', default: t('helpers.links.show')), post, class: "btn btn-outline-info btn-sm" %></td>
          <td><%= link_to t('.edit', default: t('helpers.links.edit')), edit_post_path(post), class: "btn btn-outline-success btn-sm" %></td>
          <td><%= link_to t('.destroy', default: t('helpers.links.destroy')), post, class: "btn btn-outline-danger btn-sm", method: :delete, data: { confirm: t('.confirm', default: t('helpers.links.confirm')) } %></td>
        </tr>
      <% end %>
    </tbody>
  </table>

  <br>

  <%= link_to t('.new', default: t('helpers.links.new', model: model_class.model_name.human)), new_post_path, class: "btn btn-primary" %>

app/views/posts/new.html.erb
<% model_class = Post %>
  <div class="my-4">
    <h1><%= t('.new', default: t('helpers.titles.new', model: model_class.model_name.human)) %></h1>
  </div>

  <%= render 'form', post: @post %>

  <%= link_to t('.back', default: t('helpers.links.back')), posts_path, class: "btn btn-danger btn-sm" %>

app/views/posts/show.html.erb
<% model_class = Post %>

  <div class="my-4">
    <h1><%= model_class.model_name.human.titleize %></h1>
  </div>
  <div class="card">
    <div class="card-header">
      <h4 class="card-title"><%= @post.title %></h4>
      <h6 class="text-muted">Posted by
        <%= @post.author %></h6>
    </div>
    <div class="card-body">
      <p class="card-text"><%= @post.content %></p>
      <%= link_to t('.edit', default: t('helpers.links.edit')), edit_post_path(@post), class: "btn btn-success btn-sm" %>
      |
      <%= link_to t('.back', default: t('helpers.links.back')), posts_path, class: "btn btn-danger btn-sm" %>
    </div>
  </div>

app/views/users/shared/_links.html.erb
<%- if controller_name != 'sessions' %>
  <%= link_to "Log in", new_session_path(resource_name) %><br />
<% end -%>

<%- if devise_mapping.registerable? && controller_name != 'registrations' %>
  <%= link_to "Sign up", new_registration_path(resource_name) %><br />
<% end -%>

<%- if devise_mapping.recoverable? && controller_name != 'passwords' && controller_name != 'registrations' %>
  <%= link_to "Forgot your password?", new_password_path(resource_name) %><br />
<% end -%>

<%- if devise_mapping.confirmable? && controller_name != 'confirmations' %>
  <%= link_to "Didn't receive confirmation instructions?", new_confirmation_path(resource_name) %><br />
<% end -%>

<%- if devise_mapping.lockable? && resource_class.unlock_strategy_enabled?(:email) && controller_name != 'unlocks' %>
  <%= link_to "Didn't receive unlock instructions?", new_unlock_path(resource_name) %><br />
<% end -%>

<%- if devise_mapping.omniauthable? %>
  <%- resource_class.omniauth_providers.each do |provider| %>
    <%= link_to "Sign in with #{OmniAuth::Utils.camelize(provider)}", omniauth_authorize_path(resource_name, provider) %><br />
  <% end -%>
<% end -%>